package com.redhat.training.collector;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.MessageConsumer;
import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class CollectMetric {
    public static void main(String... args) {
        Logger LOG = LoggerFactory.getLogger(CollectMetric.class);

        // declare connection objects
        InitialContext ctx;
        ConnectionFactory cf;
        Connection c;
        Session s;
        MessageConsumer mc;
        Queue q;
        
        try {
            ctx = new InitialContext();
            cf = (ConnectionFactory)ctx.lookup("ConnectionFactory");
            q = (Queue)ctx.lookup("queue/metrics");
        } catch (NamingException ne) {
            ne.printStackTrace();
            return;
        }

        try {
            c = cf.createConnection();
            c.start();

            s = c.createSession();
            mc = s.createConsumer(q);
        } catch (JMSException je) {
            je.printStackTrace();
            return;
        }

        while (true) {
            try {
                TextMessage tm = (TextMessage)mc.receive(1000);

                if (tm != null) {
                    LOG.info("Got: " + tm.getText());
                }

                continue;
            } catch (JMSException je) {
                je.printStackTrace();
            }

            try {
                Thread.sleep(1000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }
}
