package com.redhat.training.stock.receive;

import java.util.UUID;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.Topic;
import javax.jms.TopicSubscriber;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class Subscribe {
    public static void main(String... args) {
        Logger LOG = LoggerFactory.getLogger(Subscribe.class);

        // prepare connection objects
        InitialContext ctx;
        ConnectionFactory cf;
        Connection c;
        Session s;
        TopicSubscriber ts;
        Topic t;
        
        try {
            ctx = new InitialContext();
            cf = (ConnectionFactory)ctx.lookup("ConnectionFactory");
            t = (Topic)ctx.lookup("topic/stocks");
        } catch (NamingException ne) {
            ne.printStackTrace();
            return;
        }

        String cid;
        if (args.length == 0 || args[0] == "") {
            cid = UUID.randomUUID().toString();
        } else {
            cid = args[0];
        }
        String sid = "stockticks";
        try {
            c = cf.createConnection();
            c.setClientID(cid);
            c.start();

            s = c.createSession();
            ts = s.createDurableSubscriber(t, sid);

            LOG.info("Created a durable subscriber (ID " + cid + " for topic " + t.getTopicName() + " (SID " + sid + ")");
        } catch (JMSException je) {
            je.printStackTrace();
            return;
        }

        while (true) {
            try {
                TextMessage tm = (TextMessage)ts.receive(1000);

                if (tm != null) {
                    LOG.info("Got: " + tm.getText());
                }

                continue;
            } catch (JMSException je) {
                je.printStackTrace();
            }

            try {
                Thread.sleep(1000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }
}
