package com.redhat.training.stock.send;

import java.util.Random;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.Topic;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class Update {
    public static void main(String... args) {
        Logger LOG = LoggerFactory.getLogger(Update.class);

        String[] stocks = {
            "RHT",
            "DOW",
            "IBM",
            "VMW"
        };

        // prepare connection objects
        InitialContext ctx;
        ConnectionFactory cf;
        Connection c;
        Session s;
        MessageProducer mp;
        Topic t;
        
        try {
            ctx = new InitialContext();
            cf = (ConnectionFactory)ctx.lookup("ConnectionFactory");
            t = (Topic)ctx.lookup("topic/stocks");
        } catch (NamingException ne) {
            ne.printStackTrace();
            return;
        }

        try {
            c = cf.createConnection();
            c.start();

            s = c.createSession();
            mp = s.createProducer(t);

        } catch (JMSException je) {
            je.printStackTrace();
            return;
        }

        Random r = new Random();
        while (true) {
            String report = stocks[r.nextInt(stocks.length)] + ": " + r.nextInt(999);
            LOG.info(report);

            try {
                TextMessage tm = s.createTextMessage(report);
                mp.send(tm);
            } catch (JMSException je) {
                je.printStackTrace();
            }

            try {
                Thread.sleep(1000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }
}
